import xbmc
import xbmcgui
import json
import xbmcplugin

def play_hls_content(hls_info, addon_handle):
    try:
        # Se l'URL è diretto (non un oggetto JSON)
        if hls_info.startswith('http'):
            play_url = hls_info
        else:
            # Altrimenti prova a parsare come JSON
            hls_info = hls_info.replace("'", '"')
            channel = json.loads(hls_info)
            play_url = channel.get('hls_url', '')

        if play_url:
            user_agent = 'User-Agent=Mozilla/5.0 (Linux; Android 11.0; Build/RTK2.230523.082) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.159 Safari/537.36 CrKey/1.56.500000 DeviceType/AndroidTV'
            
            list_item = xbmcgui.ListItem(path=play_url)
            list_item.setProperty('IsPlayable', 'true')
            list_item.setProperty('inputstream', 'inputstream.adaptive')
            list_item.setProperty('inputstream.adaptive.stream_headers', f'User-Agent={user_agent}')
            
            play_url = play_url + '|User-Agent=' + user_agent
            xbmc.executebuiltin("PlayMedia(" + play_url + ")")
            xbmcplugin.setResolvedUrl(addon_handle, True, listitem=list_item)
        else:
            xbmc.log("URL HLS non trovato", level=xbmc.LOGERROR)
            xbmcgui.Dialog().notification('Errore', 'URL HLS non trovato', xbmcgui.NOTIFICATION_ERROR, 5000)
    except Exception as e:
        xbmc.log(f"Errore generale in play_hls_content: {str(e)}", level=xbmc.LOGERROR)
        xbmcgui.Dialog().notification('Errore', 'Errore durante la riproduzione HLS', xbmcgui.NOTIFICATION_ERROR, 5000)
