import xbmc
import xbmcgui
import json
import xbmcplugin

def play_mpd_content(mpd_info, addon_handle):
    try:
        mpd_info = mpd_info.replace("'", '"')
        channel = json.loads(mpd_info)
        if channel and 'mpd_url' in channel:
            # Usa l'user-agent dal JSON, altrimenti usa quello di default
            default_ua = 'User-Agent=Mozilla/5.0 (Linux; Android 11.0; Build/RTK2.230523.082) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.159 Safari/537.36 CrKey/1.56.500000 DeviceType/AndroidTV'
            user_agent = channel.get('stream_headers', default_ua)            
            xbmc.log(f"Channel data: {channel}", level=xbmc.LOGINFO)
            xbmc.log(f"User-Agent: {user_agent}", level=xbmc.LOGINFO)
            
            play_url = channel['mpd_url']

            list_item = xbmcgui.ListItem(path=play_url)

            list_item.setMimeType('application/octet-stream')

            # Aggiungi stream_params solo per MPD specifici
            if "mpd" in play_url:
                list_item.setProperty('inputstream', 'inputstream.adaptive')
                list_item.setProperty('inputstream.adaptive.stream_headers', user_agent)
                list_item.setProperty('inputstream.adaptive.manifest_headers', user_agent)
                list_item.setProperty('inputstream.adaptive.max_resolution', 'max')
                # Gestione delle chiavi ClearKey (singola o multiple)
                if 'license_key' in channel:
                    license_key = channel['license_key']
                    
                    # Controllo se è una stringa singola o un dizionario
                    if isinstance(license_key, str):
                        # Caso singola coppia di chiavi
                        list_item.setProperty('inputstream.adaptive.drm_legacy', f'org.w3.clearkey|{license_key}')
                    elif isinstance(license_key, dict):
                        # Caso multiple coppie di chiavi
                        # Costruisci la stringa delle chiavi concatenate
                        keys_string = ','.join([f"{kid}:{key}" for kid, key in license_key.items()])
                        list_item.setProperty('inputstream.adaptive.drm_legacy', f'org.w3.clearkey|{keys_string}')
                    else:
                        xbmc.log("Formato chiave non riconosciuto", level=xbmc.LOGERROR)
                        return

            # Risolvi l'URL
            xbmcplugin.setResolvedUrl(addon_handle, True, listitem=list_item)
        else:
                xbmc.log("Canale non trovato o manca l'URL MPD", level=xbmc.LOGERROR)
    except Exception as e:
        xbmc.log(f"Errore generale in play_mpd_content: {str(e)}", level=xbmc.LOGERROR)
        xbmcgui.Dialog().notification('Errore', 'Errore durante la riproduzione MPD', xbmcgui.NOTIFICATION_ERROR, 5000)